<script>

import TreeItem from './lib/TreeItem.svelte'
import ToolButton from './lib/ToolButton.svelte'
import DynamicList from './lib/DynamicList.svelte'

import { TreeNode } from './library.js'

import parts_cat from './assets/parts-cat.txt'
import electro_cat from './assets/electro-cat.txt'
import home_cat from './assets/home-cat.txt'

let tree = [
  {name: "Name1", children: [{name: "Name2"}, {name: "Name3", children: [{name: "Name4"}]}, {name: "Name9"}]},
  {name: "Name5", children: [{name: "Name6"}, {name: "Name7", children: [{name: "Name8"}]}]}
]

//....................................................................................

let hidden_parts = false
let root1 = new TreeNode("Запчасти", {unfolded: true})
let root2 = new TreeNode("Электроника", {unfolded: true})
let root3 = new TreeNode("Бытовые товары", {unfolded: true})

root1.loadIndentedFile(parts_cat).then(updateTree)
root2.loadIndentedFile(electro_cat).then(updateTree)
root3.loadIndentedFile(home_cat).then(updateTree)

let catalogs = [root1, root2, root3]
let root = catalogs[0]

//....................................................................................


function updateTree() {
  root = root
}

function deleteCatalog(evt) {
  let index = evt.detail.getData("drop_on_button")
  if (index) {
    catalogs.splice(index, 1)
    catalogs = catalogs
  }
}

function deleteSelected() {
  hidden_parts = true
  root.enableSelected(false)
  updateTree()
}

function restoreDeleted() {
  root.setEnabled(true)
  hidden_parts = false
  updateTree()
}

function cleanup() {
  root.cleanupMarked()
  updateTree()
}

function newCatalog() {
  let cat = new TreeNode("Новый каталог")
  catalogs.push(cat)
  catalogs = catalogs
}

function chooseCatalog(evt) {
  root = catalogs[evt.detail]
}

</script>

<!--<img src="/src/assets/ugautodetal-logo.svg" alt="ugautodetal" height="32px"/>-->


<!--
<ToolButton symbol="delete" on:click={deleteSelected}/>
<ToolButton symbol="undo" on:click={restoreDeleted} highlight={hidden_parts}/>

<button on:click={restoreDeleted} style="color: {hidden_parts ? 'orange' : 'black'}" title="восстановить">
  <span class="material-symbols-outlined">undo</span>
</button>
-->

<span class="left-column">
  <div class="tool-panel-left">
      <img src="./src/assets/ugautodetal-logo.svg" alt="ugautodetal"/>
  </div>
  <DynamicList items={catalogs} on:new={newCatalog} on:choose={chooseCatalog} active_item={root}/>
</span>
<span class="separator"></span>
<span class="right-column">
  <div class="tool-panel-right">
    <ToolButton symbol="edit"/>
    <ToolButton symbol="delete" on:click={deleteSelected} on:drop={deleteCatalog}/>
    <ToolButton symbol="undo" on:click={restoreDeleted} highlight={hidden_parts}/>
  </div>
  <div class="tree-panel">
    <ul>
    <TreeItem bind:root={root} on:update={updateTree} on:cleanup={cleanup}/>
    </ul>
  </div>
</span>

<style>

.left-column {
  height: 100%;
  width: 25%;
}

.right-column {
  height: 100%;
  width: 80%;
}

.tree-panel {

  padding-bottom: 50px;
}

.tree-panel ul {
  margin:0px;
  background: none;
}

.separator {
  width: 20px;
}

.tool-panel-right {
  display: flex;
  align-items: flex-end;
  padding-bottom: 10px;
  justify-content: right;
  height: 120px;
  border-bottom: solid black 1px;
}

.tool-panel-left {
  display: flex;
  align-items: flex-end;
  padding-bottom: 30px;
  justify-content: left;
  height: 100px;
  border-bottom: solid black 1px;
}

</style>